#ifndef NES_H
#define NES_H

enum {
	NES_PRIORITY_NORMAL=0,
	NES_PRIORITY_ABOVENORMAL,
	NES_PRIORITY_HIGHEST,
	
	NES_PRIORITY_AUTO,
	
	NES_PRIORITY_MAX
};
enum {
	NES_ACTION_NONE=0,
	NES_ACTION_RESET,
	NES_ACTION_SOUND,
	NES_ACTION_VIDEOFORMAT,
	NES_ACTION_CORRECTASPECT,
	NES_ACTION_STRETCHFIT,
	NES_ACTION_ZOOM,
	NES_ACTION_SCREENMODE,
	NES_ACTION_CPUSPEEDMIN,
	NES_ACTION_CPUSPEEDPLUS,
	NES_ACTION_CPUSPEEDNORMAL,
	NES_ACTION_CARTSWITCHUP,
	NES_ACTION_CARTSWITCHDOWN,
	
	NES_ACTION_MAX
};

void nes_init(void);
void nes_clean(void);
int nes_start(void);
void nes_stop(int);
int __fastcall nes_is_running(void);
void __fastcall nes_set_priority(int);
int nes_get_priority(void);
int nes_get_priority_auto(void);
const char* nes_get_priority_name(u32);
void nes_open(void);
void nes_reload(void);
void nes_drop(WPARAM);
void __fastcall nes_set_action(int,int);
int nes_get_filterindex(void);
void __fastcall nes_set_paused(int);
int __fastcall nes_get_paused(void);

#endif /* NES_H */
