#ifndef PPU_MEMORYMAP_H
#define PPU_MEMORYMAP_H

void ppu_memmap_init(void);
void ppu_memmap_clean(void);

void ppu_memmap_printf_internal_nametable(int);

typedef __fastcall void(*fp_ppubusoverride)(u16);
void ppu_memmap_set_ppubusoverride(fp_ppubusoverride);

u8* ppu_memmap_get_buffer_ptr(void);
u8* ppu_memmap_get_palette_ptr(void);
u8** ppu_memmap_get_cur_name_ptr(void);
u8** ppu_memmap_get_name_ram_ptr(void);

/* handlers */
u8 __fastcall ppu_read_pt0a(u16);
u8 __fastcall ppu_read_pt0b(u16);
u8 __fastcall ppu_read_pt0c(u16);
u8 __fastcall ppu_read_pt0d(u16);
u8 __fastcall ppu_read_pt1a(u16);
u8 __fastcall ppu_read_pt1b(u16);
u8 __fastcall ppu_read_pt1c(u16);
u8 __fastcall ppu_read_pt1d(u16);
u8 __fastcall ppu_read_name0(u16);
u8 __fastcall ppu_read_name1(u16);
u8 __fastcall ppu_read_name2(u16);
u8 __fastcall ppu_read_name3(u16);

void __fastcall ppu_write_pt0a(u16,u8);
void __fastcall ppu_write_pt0b(u16,u8);
void __fastcall ppu_write_pt0c(u16,u8);
void __fastcall ppu_write_pt0d(u16,u8);
void __fastcall ppu_write_pt1a(u16,u8);
void __fastcall ppu_write_pt1b(u16,u8);
void __fastcall ppu_write_pt1c(u16,u8);
void __fastcall ppu_write_pt1d(u16,u8);
void __fastcall ppu_write_name0(u16,u8);
void __fastcall ppu_write_name1(u16,u8);
void __fastcall ppu_write_name2(u16,u8);
void __fastcall ppu_write_name3(u16,u8);

u8 __fastcall ppu_read_palette(u16);
void __fastcall ppu_write_palette(u16,u8);


u8 __fastcall ppu_read_pt0a_override(u16);
u8 __fastcall ppu_read_pt0b_override(u16);
u8 __fastcall ppu_read_pt0c_override(u16);
u8 __fastcall ppu_read_pt0d_override(u16);
u8 __fastcall ppu_read_pt1a_override(u16);
u8 __fastcall ppu_read_pt1b_override(u16);
u8 __fastcall ppu_read_pt1c_override(u16);
u8 __fastcall ppu_read_pt1d_override(u16);
u8 __fastcall ppu_read_name0_override(u16);
u8 __fastcall ppu_read_name1_override(u16);
u8 __fastcall ppu_read_name2_override(u16);
u8 __fastcall ppu_read_name3_override(u16);

void __fastcall ppu_write_pt0a_override(u16,u8);
void __fastcall ppu_write_pt0b_override(u16,u8);
void __fastcall ppu_write_pt0c_override(u16,u8);
void __fastcall ppu_write_pt0d_override(u16,u8);
void __fastcall ppu_write_pt1a_override(u16,u8);
void __fastcall ppu_write_pt1b_override(u16,u8);
void __fastcall ppu_write_pt1c_override(u16,u8);
void __fastcall ppu_write_pt1d_override(u16,u8);
void __fastcall ppu_write_name0_override(u16,u8);
void __fastcall ppu_write_name1_override(u16,u8);
void __fastcall ppu_write_name2_override(u16,u8);
void __fastcall ppu_write_name3_override(u16,u8);

u8 __fastcall ppu_read_palette_override(u16);
void __fastcall ppu_write_palette_override(u16,u8);

#endif /* PPU_MEMORYMAP_H */
